Subject: Re: bug#36942: Reconfigure broke GRUB

From: [email-masked] (Jakob L. Kreuze)
Date: Tue, 06 Aug 2019 09:30:59 -0400

Hi ison,

Thanks for opening a new ticket for tracking this.

ison <[email-masked]> writes:

> Continuing this issue from https://issues.guix.gnu.org/issue/36878
>
> guix reconfigure recently broke GRUB for me. When rebooting I get
> dropped to a "grub rescue>" shell with an error about
> "grub_file_filters" being an unknown symbol.
> If I try doing the usual commands to tell GRUB how to boot I just
> see the above error repeated, or "unknown command" when I run
> things such as insmod or "configfile".
>
> So to fix the problem I can boot to a Guix install disk and do
> "guix init" which rebuilds the system using older package
> definitions from the disk.
> That allows me to get a working system, but if I do another
> "guix pull" and reconfigure using the same config file it breaks
> GRUB again when I reboot. "guix describe" shows that my latest
> attempt was with commit 35600cd.
>
> Here is the bootloader and filesystem sections of my config:
>   (bootloader (bootloader-configuration
>                 (bootloader grub-efi-bootloader)
>                 (target "/boot/efi")))
>   (file-systems (cons* (file-system
>                          (device "/dev/sda2")
>                          (mount-point "/boot/efi")
>                          (type "vfat"))
>                        (file-system
>                          (device (file-system-label "guixsd-root"))
>                          (mount-point "/")
>                          (type "ext4"))
>                        %base-file-systems))

This narrows it down quite a bit -- I suspect that we're broken for
'grub-efi-bootloader', since I've been able to successfully reconfigure
with 'grub-bootloader' on both of my machines.

> I should make a note that I usually don't use efi, and I'm not
> completely confident it's all set up properly. I do have a
> "BIOS boot" partition on /dev/sda1 too, is that even needed with
> efi?

I don't believe so. I think the ESP partition on /dev/sda2 is all you
need.

> Although, I have been using this setup, and the above
> definitions, for about 6 months now without any bootloader or
> filesystem issues. And the same config is being used to fix the
> system when GRUB breaks as well as to reconfigure afterward
> (causing the breakage). So my guess is some new update is the
> culprit.

It certainly sounds like it, and I'm the last person to have touched the
bootloader installation code :)

I'll look into this ASAP. Thanks again for the bug report!

Regards,
Jakob